<template>
  <b-card no-body>
    <template
      v-if="header"
      #header
    >
      <b-row class="pt-2">
        <b-col>
          <slot name="header" />
        </b-col>
        <b-col
          sm="6"
          md="5"
        >
          <b-button-toolbar class="flex-nowrap justify-content-sm-end">
            <slot name="button-toolbar" />
            <b-button-group
              class="mx-1"
              size="md"
            >
              <!-- Upload Button -->
              <div v-if="upload">
                <b-form-file
                  ref="fileBrowse"
                  hidden
                  plain
                  @input="uploadFile"
                />
                <b-button
                  id="uploadButton"
                  variant="light"
                  @click="$refs.fileBrowse.$el.click()"
                >
                  <font-awesome-icon
                    icon="upload"
                    style="color: gray;"
                  />
                </b-button>
                <b-tooltip
                  placement="top"
                  target="uploadButton"
                  triggers="hover"
                  variant="primary"
                >
                  Upload
                </b-tooltip>
              </div>

              <!-- Download Button -->
              <b-button
                id="downloadButton"
                variant="light"
                @click="downloadCode"
              >
                <font-awesome-icon
                  icon="download"
                  style="color: gray;"
                />
              </b-button>
              <b-tooltip
                placement="top"
                target="downloadButton"
                triggers="hover"
                variant="primary"
              >
                Download
              </b-tooltip>

              <!-- Copy Button -->
              <b-button
                id="copyButton"
                v-clipboard:copy="value"
                variant="light"
              >
                <font-awesome-icon
                  icon="copy"
                  style="color: gray;"
                />
              </b-button>
              <b-tooltip
                variant="primary"
                target="copyButton"
                triggers="hover"
              >
                Copy to clipboard
              </b-tooltip>
            </b-button-group>
            <slot name="extra-button-toolbar" />
          </b-button-toolbar>
        </b-col>
      </b-row>
      <slot name="secondary-header" />
    </template>
    <slot name="body-pre-code" />
    <codemirror
      ref="editor"
      :options="codeMirrorOptions"
      :value="value"
      @input="$emit('input', $event)"
    />
    <slot name="body-post-code" />
    <template
      v-if="$slots.footer"
      #footer
    >
      <slot name="footer" />
    </template>
  </b-card>
</template>

<script lang="ts">
import Vue from 'vue';
import { codemirror } from 'vue-codemirror';

import 'codemirror/lib/codemirror.css';
import 'codemirror/mode/python/python';
import 'codemirror/theme/material.css';

interface CodeMirrorOptions {
  tabSize: number;
  readOnly: string | boolean;
  viewportMargin: number;
  mode: string;
  lineNumbers: boolean;
  theme: string;
}

export default Vue.extend({
  components: {
    codemirror,
  },

  props: {
    filename: {
      required: true,
      type: String,
    },
    header: {
      default: true,
      type: Boolean,
    },
    readOnly: {
      default: false,
      type: Boolean,
    },
    upload: {
      default: false,
      type: Boolean,
    },
    value: {
      required: true,
      type: String,
    },
  },

  data() {
    return {
      uploading: false,
    };
  },

  computed: {
    codeMirrorOptions(): CodeMirrorOptions {
      return {
        lineNumbers: true,
        mode: 'python',
        readOnly: this.readOnly,
        tabSize: 4,
        theme: 'material',
        viewportMargin: Infinity,
      };
    },
  },

  methods: {
    uploadFile(file: File) {
      this.uploading = true;
      const reader = new FileReader();
      reader.readAsText(file);
      reader.onloadend = () => {
        this.$emit('input', reader.result);
        this.uploading = false;
      };
    },

    downloadCode() {
      const blob = new Blob([this.value], { type: '/text/plain' });
      const link = document.createElement('a');
      link.href = URL.createObjectURL(blob);
      link.download = this.filename;
      link.click();
      URL.revokeObjectURL(link.href);
    },

    refresh() {
      this.$nextTick(() => (<any> this.$refs.editor).refresh());
    },
  },
});
</script>

<style>
.CodeMirror {
  height: 50em;
}
</style>
